/*******************************************************************************************
//
//      strtoken.c
//	      Copyright (c) 2006 - 2007
//		      Institute for Chemical Research, Kyoto University
//
*******************************************************************************************/
#include "linkdb.h"
#include "strtoken.h"

char *strtoken(char *s1, const char *s2){
	static char *head;
	char *token, *p;

	if( s1 != NULL ){
		token = s1;
	}else{
		if(head == NULL){
			return NULL;
		}
		token = head;
	}

	p = strchr(token, s2[0]);

	if( p != NULL ){
		*p = '\0';
		p++;
		head = p;
	}else{
		head = NULL;
	}
	return token;
}

char *strtoken2(char *s1){
	static char *head;
	char *token, *p;

	if( s1 != NULL ){
		token = s1;
	}else{
		if(head == NULL){
			return NULL;
		}
		while( *head == 0x20 || *head == 0x09 ){ head++; }
		if( *head == '\0' ){
			return NULL;
		}
		token = head;
	}
	p = token;
	while( *p != 0x20 && *p != 0x09 && *p != '\0' ){
		p++;
	}
	
	if( *p != '\0' ){
		*p = '\0';
		p++;
		head = p;
	}else{
		head = NULL;
	}
	return token;
}
