
#include "dbget.h"
#include "aaindex.h"

using namespace std;

Aaindex::Aaindex():
    _entry("H"),
    _description("D"),
    _delim("//"),
    _title_description(""){}

Aaindex::~Aaindex(){}

void Aaindex::parser(ifstream& ifs,
		  string& buf){

  if( buf.find(_entry) == 0 ){
    set_offset(ifs,buf);
    _header = _entry;
    buf = buf.substr(_header.length());
    set_id(buf);
  }

  else if( buf.find(_description) == 0 ){
    _header = _description;
    buf = buf.substr(_header.length());
    _title_description = trimLeftSpaces(buf);
  }

  // 何かの継続行
  else if( buf.find(" ") == 0 ){
    if( _header == _description ){
      extend_title(_title_description,buf);
    }
  }

  // エントリ終了処理
  else if( buf.find(_delim) == 0 ){
    set_size(ifs);
    writer();
  }

  // 何かのヘッダ行
  else{
    set_header(buf);
  }

}

void Aaindex::writer(){

  _title = _title_description;

  Seqnew::writer();

  clear();
}

void Aaindex::clear(){

  Seqnew::clear();

  _title_description = "";

}
