
#include <iostream>
#include <fstream>
#include <string>

#include <csignal>
#include <sys/types.h>
#include <sys/wait.h>

#include <cstdlib>    // for getenv 
#include <vector>
#include <list>
#include <map>

using namespace std;

template < typename T > std::string to_string( const T& n )
{
  std::ostringstream stm ;
  stm << n ;
  return stm.str() ;
}

class usage {
public:
  usage(){

  int MAXPROCS = 1;

#ifdef MAX_PROCS
  MAXPROCS = MAX_PROCS;
#endif

    cerr << "Usage : bfind [option] dbname expression <...>" << endl;
    cerr << "Option : " << endl;
    cerr << "  -C            Insist on the case sensitive search." << endl;
    cerr << "  -W            Indicates word matching." << endl;
    cerr << "  -m            Change from standard error output to standard output." << endl;
    cerr << "  -a            Convert output format. " << endl;
    cerr << "                   dbname:accession entry [accession] title " << endl;
    cerr << "  -n            Convert output format. " << endl;
    cerr << "                   entry [accession] title " << endl;
    cerr << "  -p <dbtab file>" << endl;
    cerr << "                Alternative dbtab." << endl;
    cerr << "  -t <dbtype> -d <directory>" << endl;
    cerr << "                <dbtype> is database type." << endl;
    cerr << "                <directory> is directory where database index files are located." << endl;
    cerr << "  -l <number>" << endl;
    cerr << "                Specify number of displaying result.(>0)" << endl;
    cerr << "  -P <number>" << endl;
    cerr << "                Specify number of process.(Min:1 Max:";
    cerr << MAXPROCS;
    cerr << ")" << endl;
    cerr << "  -h            Print this message and exit." << endl;
    cerr << "  -V            Print the version number of DBGET and exit." << endl;
  }
};

int getdata(list<string>&, multimap<string,string>&, list<string>&, string&);
void setProcData(list<ProcData>&,string&,bool);
bool search(lci&,lci&,list<ProcData>::const_iterator&,
	    string&,int, int [][256], int, bool, bool);
bool search(lci&,lci&,list<ProcData>::const_iterator&,
	    string&,int, int [][256], int, bool, bool, ostream&);
string setTempFileName();
void displayResult(string&,int&,int&);
int boyer_moore(const char *,const char *,int,int,int *,bool);
void clearTempFile(int);
void clearTempFileForChild(int);
void convert_a(char *,const string&);
void convert_n(char *);
