
#include <iostream>
#include <fstream>
#include <string>

#include <cstdlib>    // for getenv
#include <vector>
#include <list>
#include <map>

#include <fcntl.h>    // for fd = open(file, O_RDWR|O_CREAT|O_TRUNC, 0644);
#include <cdb.h>

using namespace std;

class usage {
public:
  usage(){
    cerr << "Usage : bget [option] dbname identifier <...>" << endl;
    cerr << "        bget [option] dbname1:identifier1 <dbname2:identifier2 ...>" << endl;
    cerr << "Option : " << endl;
    cerr << "   -f            Print sequences by FASTA format." << endl;
    cerr << "   -n <sequence number>,... " << endl;
    cerr << "                 Print particular sequence(s) specified with <sequence number>. " << endl;
    cerr << "                 -n option is valid only if used with -f." << endl;
    cerr << "   -m            Change from standard error output to standard output. " << endl;
    cerr << "   -p <dbtab file> " << endl;
    cerr << "                 Alternative dbtab. " << endl;
    cerr << "   -t <dbtype> -d <directory> " << endl;
    cerr << "                 <dbtype> is database type." << endl;
    cerr << "                 <directory> is directory where database index files are located. " << endl;
    cerr << "   -h            Print this message and exit." << endl;
    cerr << "   -V            Print the version number of DBGET and exit. " << endl;
  }
};

int getdata(list<string>&, multimap<string,string>&, list<string>&,
	    string&, bool, bool, bool, bool, list<string>&);

bool get_index_mcdb(struct mcdb *,struct mcdb_mmap *,string&,string&,int64_t&,int64_t&);
bool get_index(struct cdb *,string&,string&,int64_t&,int64_t&);
void get_contents(string&,string&,int64_t&,int64_t&);

string check_seq_number(vector<string>::const_iterator&,string&,int);

bool display(vector<string>::const_iterator&,string&,int);
bool display_mol(vector<string>::const_iterator&,string&);
bool display_knapsack_kcf(vector<string>::const_iterator&,string&);

void display_data(int,const int64_t,const int64_t);
void display_seqdata(int,const int64_t,const int64_t,int);
void display_seqdata(int,const string&,const int64_t,const int64_t,int);

void display_seqdata(int,const string&,const int64_t,const int64_t,
		     vector<string>::const_iterator&,int);

void setAminoCode(map<string,string>&);
string convAminoCode(const string&,map<string,string>&);

bool get_seq_numbers(list<string>&,
		     list<string>::iterator&,
		     list<string>& seq_numbers);
