
#include <iostream>
#include <fstream>
#include <string>

#ifdef CC_VERSION2
#include <strstream>  // if gcc is older than v3.0
#include <stdio.h>    // for BUFSIZ
#else
#include <sstream>
#endif

#include <unistd.h>   // for STDOUT_FILENO and STDERR_FILENO

#include <cstdlib>    // for getenv 
#include <list>
#include <map>

#include <fcntl.h>   // for fd = open(file, O_RDWR|O_CREAT|O_TRUNC, 0644);
#include <cdb.h>

using namespace std;

int netdbget = 0, verbose = 0, debug = 0;

class usage {
public:
  usage(){

    bool mcdb = false;

#ifdef MCDB
    mcdb = true;
#endif

    cerr << "btab : Have to specify a database name." << endl;
    cerr << "Usage : btab [option1] [option3] dbname" << endl;
    cerr << "        btab [option3] option2 filename" << endl;
    cerr << "Option1 : " << endl;
    cerr << "  -l            dbkey listing." << endl;
    cerr << endl;
    cerr << "Option2 : " <<endl;
    cerr << "  -o            Output dbtab image to file." << endl;
    if (mcdb) {
      cerr << "  --cdb         Create index with TinyCDB." << endl;
      cerr << "  --mcdb        Create index with mcdb.(default)" << endl;
    }
    else {
      cerr << "  --cdb         Create index with TinyCDB.(default)" << endl;
      cerr << "  --mcdb        Create index with mcdb." << endl;
    }
    cerr << endl;
    cerr << "Option3 : " << endl;
    cerr << "  -v            Verbose mode." << endl;
    cerr << "  -p <dbtab file>" << endl;
    cerr << "                Alternative dbtab." << endl;
    cerr << "  -m            Change from standard error output to standard output." << endl;
    cerr << "  -h            Print this message and exit." << endl;
    cerr << "  -V            Print the version number of DBGET and exit." << endl;
  }
};

bool writeCDB(const string&,
	      multimap<string,BasicInfo>&,
	      list<string>&,bool&);

bool create_cdb(const string&,const string&);
bool create_mcdb(const string&,const string&);

/***
void writeFileB(const string&,
		multimap<string,BasicInfo>&,
		multimap<string,string>&,
		list<string>&);

***/
