
#include <iostream>
#include <fstream>
#include <string>

#include <cstdlib>    // for getenv 
#include <vector>
#include <list>
#include <map>

#include <fcntl.h>   // for fd = open(file, O_RDWR|O_CREAT|O_TRUNC, 0644);
#include <cdb.h>

using namespace std;

class usage {
public:
  usage(){
    cerr << "Usage : btit [option] dbname identifier <...>" << endl;
    cerr << "        btit [option] dbname1:identifier1 <dbname2:identifier2 ...>" << endl;
    cerr << "Option : " << endl;
    cerr << "   -m            Change from standard error output to standard output. " << endl;
    cerr << "   -a            Convert output format. " << endl;
    cerr << "                    dbname:accession entry [accession] title " << endl;
    cerr << endl;
    cerr << "   -n            Convert output format. " << endl;
    cerr << "                    entry [accession] title " << endl;
    cerr << endl;
    cerr << "   -s            Convert output format." << endl;
    cerr << endl;
    cerr << "                 For COMPOUND, DRUG, EDRUG, GLYCAN, GENES, GENOME and KO:" << endl;
    cerr << "                    dbname:entry entry (synonym) " << endl;
    cerr << endl;
    cerr << "                 For other KEGG databases:" << endl;
    cerr << "                    dbname:entry entry " << endl;
    cerr << endl;
    cerr << "   -l            Convert output format." << endl;
    cerr << endl;
    cerr << "                 For GENES, GENOME and KO:" << endl;
    cerr << "                    dbname:entry synonym; definition" << endl;
    cerr << endl;
    cerr << "                 For COMPOUND, DRUG, EDRUG and GLYCAN:" << endl;
    cerr << "                    dbname:entry synonym" << endl;
    cerr << endl;
    cerr << "                 For other KEGG databases:" << endl;
    cerr << "                    dbnanme:entry" << endl;
    cerr << endl;
    cerr << "   -p <dbtab file> " << endl;
    cerr << "                 Alternative dbtab. " << endl;
    cerr << "   -t <dbtype> -d <directory> " << endl;
    cerr << "                 <dbtype> is database type." << endl;
    cerr << "                 <directory> is directory where database index files are located. " << endl;
    cerr << "   -h            Print this message and exit." << endl;
    cerr << "   -V            Print the version number of DBGET and exit. " << endl;
  }
};

int getdata(list<string>&, multimap<string,string>&, list<string>&, string&);
bool display(string&,string&,string&);
bool display_alt(string&,string&);
