
#include "dbget.h"
#include "carbbank.h"

using namespace std;

Carbbank::Carbbank():
    _entry("CC: CCSD:"),
    _def("TI:"),
    _delim("==="),
    _title_def(""){}

Carbbank::~Carbbank(){}

void Carbbank::parser(ifstream& ifs,
		   string& buf){

  if( buf.find(_entry) == 0 ){
    set_offset(ifs,buf);
    _header = _entry;
    buf = buf.substr(_header.length());
    set_id(buf);
  }

  else if( buf.find(_def) == 0 ){
    _header = _def;
    buf = buf.substr(_header.length());
    _title_def = trimLeftSpaces(buf);
  }

  // 何かの継続行
  else if( buf.find(" ") == 0 ){
    if( _header == _def ){
      extend_title(_title_def,buf);
    }
  }

  // エントリ終了処理
  else if( buf.find(_delim) == 0 ){
    set_size(ifs);
    writer();
  }

  // 何かのヘッダ行
  else{
    set_header(buf);
  }

}

void Carbbank::writer(){

  _title += _title_def;

  Seqnew::writer();

  clear();
}

void Carbbank::clear(){

  Seqnew::clear();

  _title_def = "";

}
