
#ifndef  _LARGEFILE_SOURCE
# define _LARGEFILE_SOURCE 1
#endif

#ifndef _FILE_OFFSET_BITS
# define _FILE_OFFSET_BITS 64
#endif
#if _FILE_OFFSET_BITS - 0 != 64
# undef _FILE_OFFSET_BITS
# define _FILE_OFFSET_BITS 64
#endif

#include <iostream>
#include <fstream>
#include <string>
#include <vector>
#include <list>
#include <map>

#include <climits>    // for UINT_MAX

#include <string.h>
#include <stdlib.h>
#include <unistd.h>

#include <sys/stat.h> // for stat struct

#ifdef CC_VERSION2
#include <strstream>  // if gcc is older than v3.0
#include <stdio.h>    // for BUFSIZ
#else
#include <sstream>
#endif

#include <fcntl.h>   // for fd = open(file, O_RDWR|O_CREAT|O_TRUNC, 0644);
#include <cdb.h>

// MCDB
#include <mcdb.h>
#include <mcdb_makefmt.h>
#include <nointr.h>

using namespace std;

const string VERSION = "DBGET version 6.5 20221208 (release)";
const string DBTAB = "/etc/dbtab";
const int DBGET_SERVER_PORT = 3266;
const int DBGET_BUFSIZ = 8192;
const int MAXSIZE = DBGET_BUFSIZ * 10;
const int BLOCKSIZE = 30000000;

typedef multimap<string,string>::const_iterator sci;
typedef vector<string>::const_iterator vci;
typedef list<string>::const_iterator lci;

void splitToList(vector<string>&,const string&,const string&);
void splitToList(list<string>&,const string&,const string&);
void trimSpaces(string&);
void trimChars(string&,const string&);
string trimLeftSpaces(const string&);
string trimRightSpaces(const string&);
string dirname(const string&);
string basename(const string&);
void Upper(string&);
void Lower(string&);
void cat(const string&);
string itos(const int&);
bool isTNumber(const string&);
bool isRGNumber(const string&);
bool isECNumber(const string&);

bool open_index(int&, struct cdb *,const string&);
bool init_index(int& , struct cdb *);
bool get_value(struct cdb *,string&,string&);
void close_index(int,struct cdb *);

bool open_index_mcdb(int&, struct mcdb *, struct mcdb_mmap *,
                     const string&, bool&);
bool init_index_mcdb(int&, struct mcdb *, struct mcdb_mmap *);
bool get_value_mcdb(struct mcdb *, struct mcdb_mmap *,
                    string&,string&);
void close_index_mcdb(int, struct mcdb_mmap *);

inline int mystoi(const string& str){
  return atoi(str.c_str());
}
inline int mystol(const string& str){
  return atol(str.c_str());
}

inline int chLower(int ch){
  if( ch >= 0x41 && ch <= 0x5a )
    ch += 0x20;
  return ch;
}
inline int chUpper(int ch){
  if( ch >= 0x61 && ch <= 0x7a )
    ch -= 0x20;
  return ch;
}


