
#include "dbget.h"
#include "disease_ja.h"

using namespace std;

Disease_ja::Disease_ja():
    _entry("エントリ"),
    _name("名称"),
    _category("カテゴリ"),
    _pathway("パスウェイ"),
    _gene("病因遺伝子"),
    _env_factor("環境要因"),
    _marker("診断マーカー"),
    _drug("治療薬"),
    _delim("///"),
    _title_name(""),
    _title_category(""),
    _title_pathway(""),
    _title_gene(""),
    _title_env_factor(""),
    _title_marker(""),
    _title_drug(""){}

Disease_ja::~Disease_ja(){}

void Disease_ja::parser(ifstream& ifs,
		  string& buf){

  if( buf.find(_entry) == 0 ){
    set_offset(ifs,buf);
    _header = _entry;
    buf = buf.substr(_header.length());
    set_id(buf);
  }

  else if( buf.find(_name) == 0 ){
    _header = _name;
    buf = buf.substr(_header.length());
    _title_name = trimLeftSpaces(buf);
  }

  /*
  else if( buf.find(_category) == 0 ){
    _header = _category;
    buf = buf.substr(_header.length());
    _title_category = trimLeftSpaces(buf);
  }

  else if( buf.find(_pathway) == 0 ){
    _header = _pathway;
    buf = buf.substr(_header.length());
    _title_pathway = trimLeftSpaces(buf);
  }

  else if( buf.find(_gene) == 0 ){
    _header = _gene;
    buf = buf.substr(_header.length());
    _title_gene = trimLeftSpaces(buf);
  }

  else if( buf.find(_env_factor) == 0 ){
    _header = _env_factor;
    buf = buf.substr(_header.length());
    _title_env_factor = trimLeftSpaces(buf);
  }

  else if( buf.find(_marker) == 0 ){
    _header = _marker;
    buf = buf.substr(_header.length());
    _title_marker = trimLeftSpaces(buf);
  }

  else if( buf.find(_drug) == 0 ){
    _header = _drug;
    buf = buf.substr(_header.length());
    _title_drug = trimLeftSpaces(buf);
  }
  */

  // 何かの継続行
  else if( buf.find("   ") == 0 ){
    if( _header == _name ){
      extend_title(_title_name,buf);
    }
    else if( _header == _category ){
      extend_title(_title_category,buf);
    }
    /*
    else if( _header == _pathway ){
      extend_title(_title_pathway,buf);
    }
    else if( _header == _gene ){
      extend_title(_title_gene,buf);
    }
    else if( _header == _env_factor ){
      extend_title(_title_env_factor,buf);
    }
    else if( _header == _marker ){
      extend_title(_title_marker,buf);
    }
    else if( _header == _drug ){
      extend_title(_title_drug,buf);
    }
    */
  }

  // エントリ終了処理
  else if( buf.find(_delim) == 0 ){
    set_size(ifs);
    writer();
  }

  // 何かのヘッダ行
  else{
    set_header(buf);
  }

}

void Disease_ja::writer(){

  _title = _title_name;

  if( ! _title.empty() && ! _title_category.empty() )
    _title += "; ";

  _title += _title_category;

  if( ! _title.empty() && ! _title_pathway.empty() )
    _title += "; ";

  _title += _title_pathway;

  if( ! _title.empty() && ! _title_gene.empty() )
    _title += "; ";

  _title += _title_gene;

  if( ! _title.empty() && ! _title_env_factor.empty() )
    _title += "; ";

  _title += _title_env_factor;

  if( ! _title.empty() && ! _title_marker.empty() )
    _title += "; ";

  _title += _title_marker;

  if( ! _title.empty() && ! _title_drug.empty() )
    _title += "; ";

  _title += _title_drug;

  Seqnew::writer();

  clear();
}

void Disease_ja::clear(){

  Seqnew::clear();

  _title_name = "";
  _title_category = "";
  _title_pathway = "";  
  _title_gene = "";
  _title_env_factor = "";
  _title_marker = "";
  _title_drug = "";

}
