
#include "dbget.h"
#include "drug_ja.h"

using namespace std;

Drug_ja::Drug_ja():
    _entry("エントリ"),
    _name("一般名"),
    _delim("///"),
    _title_name(""){}

Drug_ja::~Drug_ja(){}

void Drug_ja::parser(ifstream& ifs,
		     string& buf){
  if( buf.find(_entry) == 0 ){
    set_offset(ifs,buf);
    _header = _entry;
    buf = buf.substr(_header.length());
    set_id(buf);
  }

  else if( buf.find(_name) == 0 ){
    _header = _name;
    buf = buf.substr(_header.length());
    _title_name = trimLeftSpaces(buf);
  }

  // 何かの継続行
  else if( buf.find("   ") == 0 ){
    if( _header == _name ){
      _title_name += " ";
      _title_name += trimLeftSpaces(buf);
    }
  }

  // エントリ終了処理
  else if( buf.find(_delim) == 0 ){
    set_size(ifs);
    writer();
  }

  // 何かのヘッダ行
  else{
    set_header(buf);
  }

}

void Drug_ja::writer(){

  _title = _title_name;

  Seqnew::writer();

  clear();
}

void Drug_ja::clear(){

  Seqnew::clear();

  _title_name = "";
}
