
#include "dbget.h"
#include "enzyme.h"

using namespace std;

Enzyme::Enzyme():
    _entry("ENTRY"),
    _name("NAME"),
    _delim("///"),
    _title_name(""){}

Enzyme::~Enzyme(){}

void Enzyme::parser(ifstream& ifs,
		    string& buf){

  if( buf.find(_entry) == 0 ){
    _header = _entry;
    set_offset(ifs,buf);

    // _id のセットは特殊処理
    // set_id() は使わない
    //ex.) ENTRY       EC 1.1.1.1                  Enzyme
    vector<string> lbuf;
    splitToList(lbuf,buf," ");
    vector<string>::const_iterator itr = lbuf.begin();

    // ENTRY が2回以上は不正
    if( ! _id.empty() )
      ++_rejected;
    else{
      // 半角スペースで分割したときの 3つ目の単語を取り出す
      _id = *(itr+2);

      // tit ファイル用の ID
      _tit_id = _abbr;
      _tit_id += ":";
      _tit_id += _id;

      ++_counter;
    }

  }

  else if( buf.find(_name) == 0 ){
    _header = _name;
    buf = buf.substr(_header.length());
    _title_name = trimLeftSpaces(buf);
  }

  // 何かの継続行
  else if( buf.find("   ") == 0 ){
    if( _header == _name ){
      extend_title(_title_name,buf);
    }
  }

  // エントリ終了処理
  else if( buf.find(_delim) == 0 ){
    set_size(ifs);
    writer();
  }

  // 何かのヘッダ行
  else{
    set_header(buf);
  }

}

void Enzyme::writer(){

  _title = _title_name;

  Seqnew::writer();

  clear();
}

void Enzyme::clear(){

  Seqnew::clear();

  _title_name = "";

}
