
#include "dbget.h"
#include "expression.h"

using namespace std;

Expression::Expression():
    _entry("ENTRY"),
    _def("DEFINITION"),
    _control("CONTROL"),
    _target("TARGET"),
    _delim("///"),
    _title_def(""),
    _title_control(""),
    _title_target(""),
    _kcf("DATA"),
    _kcf_id(""),
    _kcf_offset(0),
    _kcf_size(0){}

Expression::~Expression(){}

void Expression::parser(ifstream& ifs,
		  string& buf){

  if( buf.find(_entry) == 0 ){
    set_offset(ifs,buf);
    _header = _entry;
    buf = buf.substr(_header.length());
    set_id(buf);
  }

  else if( buf.find(_def) == 0 ){
    _header = _def;
    buf = buf.substr(_header.length());
    _title_def = trimLeftSpaces(buf);
  }

  /*
  else if( buf.find(_control) == 0 ){
    _header = _control;
    buf = buf.substr(_header.length());
    _title_control = trimLeftSpaces(buf);
  }

  else if( buf.find(_target) == 0 ){
    _header = _target;
    buf = buf.substr(_header.length());
    _title_target = trimLeftSpaces(buf);
  }
  */

  // DATA行が KCF データの開始位置
  else if( buf.find(_kcf) == 0 ){
    _header = _kcf;
    _kcf_offset = ifs.tellg();
    _kcf_offset -= buf.length();
    --_kcf_offset;
  }

  // 何かの継続行
  else if( buf.find(" ") == 0 ){
    if( _header == _def ){
      extend_title(_title_def,buf);
    }
    /*
    else if( _header == _control ){
      extend_title(_title_control,buf);
    }
    else if( _header == _target ){
      extend_title(_title_target,buf);
    }
    */
  }

  // エントリ終了処理
  else if( buf.find(_delim) == 0 ){
    set_size(ifs);
    _kcf_size = _size - ( _kcf_offset - _offset );
    writer();
  }

  // 何かのヘッダ行
  else{
    set_header(buf);
  }

}

void Expression::writer(){

  _title = _title_def;

  if( ! _title.empty() && ! _title_control.empty() )
    _title += "; ";

  _title += _title_control;

  if( ! _title.empty() && ! _title_target.empty() )
    _title += "; ";

  _title += _title_target;

  _kcf_id = "_kcf_";
  _kcf_id += _id;

  Seqnew::writer();

  if( _kcf_offset > 0 )
    Seqnew::writer(_kcf_id,_kcf_offset,_kcf_size);

  clear();
}

void Expression::clear(){

  Seqnew::clear();

  _title_def = "";
  _title_control = "";
  _title_target = "";
  _kcf_id = "";
  _kcf_offset = 0;
  _kcf_size = 0;

}
