
#include "dbget.h"

void makeskip
(list<string>& keys, int& m, int& n,
 bool& buffer_search, bool case_sensitive,
 int skip[][256],bool debug)
{

  list<string>::iterator itr;
  int key_len = 0;

  for( itr = keys.begin(); itr != keys.end(); ++itr,++m ){

    if( *itr == ".and." ) continue;

    // メモリに読み込んだ MAXSIZEバイト分のバッファ全体に対して検索
    // 評価式が AND検索のみの場合は可能
    // 一行ずつ検索するよりおよそ数倍速い
    if( *itr == ".not." || *itr == ".or." ){
      buffer_search = false;
      continue;
    }

    key_len = (*itr).length();

    for( int i = 0; i < 256; ++i )
      skip[n][i] = key_len;

    if( case_sensitive ){
      for( int i = 0; i < key_len; ++i ){
	int j = (unsigned char)(*itr)[i];
	skip[n][j] = key_len - i - 1;
      }
    }
    else{
      for( int i = 0; i < key_len; ++i ){
	int uch = chUpper((unsigned char)(*itr)[i]);
	int lch = chLower((unsigned char)(*itr)[i]);

	skip[n][uch] = key_len - i - 1;
	skip[n][lch] = key_len - i - 1;
      }
    }

    ++n;

  }

  if( debug ){
    itr = keys.begin();
    for(int i = 0; i < m; ++i, ++itr){
      if( *itr == ".and." || *itr == ".or." || *itr == ".not." ) continue;
      key_len = (*itr).length();
      for( int j = 0; j < 256; ++j ){
	//if( skip[i][j] < key_len )
	printf("######## %c skip[%d][%d] : %d\n",j,i,j,skip[i][j]);
      }
    }
  }

}
