
#include "dbget.h"
#include "network.h"

using namespace std;

Network::Network():
    _entry("ENTRY"),
    _name("NAME"),
    _def("DEFINITION"),
    _delim("///"),
    _title_name(""),
    _title_def(""){}

Network::~Network(){}

void Network::parser(ifstream& ifs,
                     string& buf){

  if( buf.find(_entry) == 0 ){
    set_offset(ifs,buf);
    _header = _entry;
    buf = buf.substr(_header.length());
    set_id(buf);
  }

  else if( buf.find(_name) == 0 ){
    _header = _name;
    buf = buf.substr(_header.length());
    _title_name = trimLeftSpaces(buf);
  }

  else if( buf.find(_def) == 0 ){
    _header = _def;
    buf = buf.substr(_header.length());
    _title_def = trimLeftSpaces(buf);
  }

  // 何かの継続行
  else if( buf.find("   ") == 0 ){
    if( _header == _name ){
      extend_title(_title_name,buf);
    }
    else if( _header == _def ){
      extend_title(_title_def,buf);
    }
  }

  // エントリ終了処理
  else if( buf.find(_delim) == 0 ){
    set_size(ifs);
    writer();
  }

  // 何かのヘッダ行
  else{
    set_header(buf);
  }

}

void Network::writer(){

  _title = _title_name;

  // DEFINITION があれば連結  
  //if( ! _title.empty() && ! _title_def.empty() )
  //  _title += "; ";
  //_title += _title_def;

  Seqnew::writer();

  clear();
}

void Network::clear(){

  Seqnew::clear();

  _title_name = "";
  _title_def = "";

}
