
#include "dbget.h"
#include "parseargs.h"

int parseargs(list<string>& arguments,
	       list<string>& option_keys,
	       multimap<string,string>& options)
{

  // 引数チェックと変数セット
  list<string>::iterator itr = arguments.begin();
  lci ktr = option_keys.begin();
  while( itr != arguments.end() ){
    if( *itr == "-h"){
      return -1;
    }else if( *itr == "-V" ){
      cout << VERSION << endl;
      return -2;
    }else if( *itr == "-m" ){
      // STDERR を STDOUT に結合
      dup2( STDOUT_FILENO, STDERR_FILENO );
      itr = arguments.erase(itr);
      continue;
    }else if( *itr == "-v" ){
      options.insert(make_pair("v","verbose"));
      itr = arguments.erase(itr);
      continue;
    }else if( *itr == "-D" ){
      options.insert(make_pair("D","debug"));
      itr = arguments.erase(itr);
      continue;
    }else if( *itr == "-N" ){
      options.insert(make_pair("N","network"));
      itr = arguments.erase(itr);
      continue;
    }else if( *itr == "-cdb"||*itr == "--cdb" ){
      options.insert(make_pair("cdb","cdb"));
      itr = arguments.erase(itr);
      continue;
    }else if( *itr == "-mcdb"||*itr == "--mcdb" ){
      options.insert(make_pair("mcdb","mcdb"));
      itr = arguments.erase(itr);
      continue;
    }

    if( (*itr)[0] == '-' ){ // not accept -aa style
      if( (*itr).length() != 2 ){
	return 0;
      }

      bool known_opt = false;
      for( ktr = option_keys.begin(); ktr != option_keys.end(); ktr++ ){
	if( (*itr)[1] == (*ktr)[0] ){
	  itr = arguments.erase(itr);
	  if( itr == arguments.end() ) return 0;
	  if( (*itr)[0] == '-' ) return 0;
	  options.insert(make_pair(*ktr,*itr));
	  known_opt = true;
	  itr = arguments.erase(itr);
	  break;
	}
      }
      if( ! known_opt )
	return 0;
      continue;
    }
    ++itr;
  }
  //if( arguments.empty() ) return 0;
  return 1;

}
