
#include "dbget.h"
#include "pmd.h"

using namespace std;

Pmd::Pmd():
    _entry("ENTRY"),
    _ti("TITLE"),
    _protein("PROTEIN "), // 半角スペースを入れておく
    _delim("///"),
    _title_ti(""),
    _title_protein(""){}

Pmd::~Pmd(){}

void Pmd::parser(ifstream& ifs,
		 string& buf){

  if( buf.find(_entry) == 0 ){
    set_offset(ifs,buf);
    _header = _entry;
    buf = buf.substr(_header.length());
    set_id(buf);
  }

  else if( buf.find(_ti) == 0 ){
    _header = _ti;
    buf = buf.substr(_header.length());
    _title_ti = trimLeftSpaces(buf);
  }

  else if( buf.find(_protein) == 0 ){
    _header = _protein;
    buf = buf.substr(_header.length());
    // PROTEIN 行はひとつのエントリに複数回現れることがある
    if( ! _title_protein.empty() )
      extend_title(_title_protein,buf);
    else
      _title_protein = trimLeftSpaces(buf);
  }

  // 何かの継続行
  else if( buf.find(" ") == 0 ){
    if( _header == _ti )
      extend_title(_title_ti,buf);
    else if( _header == _protein ){
      // # ではじまる行は追加しない
      buf = trimLeftSpaces(buf);
      if( buf[0] != '#' )
	extend_title(_title_protein,buf);
    }
  }

  // エントリ終了処理
  else if( buf.find(_delim) == 0 ){
    set_size(ifs);
    writer();
  }

  // 何かのヘッダ行
  else{
    set_header(buf);
  }

}

void Pmd::writer(){

  _title += _title_ti;

  // PRITEIN 行は大括弧で括る
  if( ! _title.empty() && ! _title_protein.empty() ){
    // PROTEIN 行の特殊処理により、
    // _title_protein の先頭は半角スペースではじまる
    _title += " [ ";
    _title += _title_protein;
    _title += " ]";
  }

  Seqnew::writer();

  clear();
}

void Pmd::clear(){

  Seqnew::clear();

  _title_ti = "";
  _title_protein = "";

}
