
#ifndef __READDBTAB__
#define __READDBTAB__

#include <iostream>
#include <fstream>
#include <string>
#include <cstdlib> // for getenv 
#include <vector>
#include <list>
#include <map>

#include <fcntl.h>   // for fd = open(file, O_RDWR|O_CREAT|O_TRUNC, 0644);
#include <cdb.h>

using namespace std;

class BasicInfo {

  string name;
  string type;
  string path;
  string nick;
  string host;
  int    port;

public:
  BasicInfo():port(DBGET_SERVER_PORT){}

  // basic information
  BasicInfo(const string& aname,
	    const string& atype,
	    const string& apath,
	    const string& anick)
    :name(aname),
     type(atype),
     path(apath),
     nick(anick),
     port(DBGET_SERVER_PORT){}

  // for netdbget, type is "netdbget"
  BasicInfo(const string& aname,
	    const string& atype,
	    const string& ahost,
	    const int aport)
    :name(aname),
     type(atype),
     host(ahost),
     port(aport){}

  const string getName() { return name; }
  const string getType() { return type; }
  const string getPath() { return path; }
  const string getNick() { return nick; }
  const string getHost() { return host; }
  const int getPort() { return port; }
};

typedef multimap<string,BasicInfo>::const_iterator mci;

void expandMacro(string&);

bool readFile(const string&,
	      const string&,
	      list<string>&,
	      string&);

bool readDbtabCDB(const string&,
		  const string&,
		  list<string>&,
		  string&);

bool readDbtabBfind(const string&,
		    const string&,
		    list<string>&,
		    string&);

bool readDbtabBfindBin(const string&,
		       const list<string>&,
		       list<string>&);

bool readDbtabBin(const string&,
		  const string&,
		  list<string>&,
		  string&);

bool readDbtab(const string&,
	       multimap<string,BasicInfo>&,
	       multimap<string,string>&,
	       list<string>&);

#endif
